package filters {
	import dtos.FilterSearchDTO;
	import dtos.UserDTO;
	
	import events.GenericArrayEvent;
	
	import flash.events.Event;
	
	import helpers.DateRangeValidator;
	import helpers.NumberRangeValidator;
	
	import mx.collections.ArrayCollection;
	import mx.containers.Box;
	import mx.controls.DateField;
	import mx.controls.Label;
	import mx.controls.TextInput;
	import mx.validators.DateValidator;
	import mx.validators.Validator;

	/**
	 *
	 * @author Jose
	 */
	public class InvoicingFilterCodeBehind extends Box {
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var userDTO:UserDTO;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var userNameTextInput:TextInput;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var passwordTextInput:TextInput;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var result:Label;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var filterSearchDTO:FilterSearchDTO;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var minStepsValidator:NumberRangeValidator;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var minSurchargesValidator:NumberRangeValidator;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var minCollectedValidator:NumberRangeValidator;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var minDateValidator:DateRangeValidator;
		/**
		 *
		 * @default
		 */
		public var maxDateValidator:DateValidator;
		/**
		 *
		 * @default
		 */
		public var validatorArr:Array=new Array();
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var inviocesList:ArrayCollection;

		[Bindable]
		public var minDate:DateField;
		[Bindable]
		public var maxDate:DateField;
		[Bindable]
		public var minSteps:TextInput;
		[Bindable]
		public var maxSteps:TextInput;
		[Bindable]
		public var minSurcharges:TextInput;
		[Bindable]
		public var maxSurcharges:TextInput;
		[Bindable]
		public var minCollected:TextInput;
		[Bindable]
		public var maxCollected:TextInput;

		/**
		 * 
		 */
		public function InvoicingFilterCodeBehind() {
			super();
		}

		/**
		 *
		 */
		public function init():void {
			validatorArr.push(minStepsValidator);
			validatorArr.push(minSurchargesValidator);
			validatorArr.push(minCollectedValidator);
			validatorArr.push(minDateValidator);
			validatorArr.push(maxDateValidator);
			filterSearchDTO=new FilterSearchDTO();
		}

		/**
		 *
		 * @return
		 */
		public function validateScreen():Boolean {
			var arrayResult:Array=Validator.validateAll(validatorArr);
			return (arrayResult.length == 0);
		}

		/**
		 *
		 * @param event
		 */
		public function searchInvoices(event:Event):void {
			if (validateScreen()) {
				cleanValidations();
				var genericArrayEvent:GenericArrayEvent=new GenericArrayEvent("InvoicingFilterCodeBehind.searchInvoices");
				filterSearchDTO.userId=new Number(userDTO.id);
				genericArrayEvent.collection.addItem(filterSearchDTO);
				dispatchEvent(genericArrayEvent);
			}
		}
		
		/**
		 *
		 */
		public function cleanValidations():void {
			minDate.errorString="";
			maxDate.errorString="";
			minSteps.errorString="";
			maxSteps.errorString="";
			minSurcharges.errorString="";
			maxSurcharges.errorString="";
			minCollected.errorString="";
			maxCollected.errorString="";
		}

		/**
		 *
		 */
		protected function clearFilter():void {
			trace("Init clearFilter");
			cleanValidations();
			filterSearchDTO=new FilterSearchDTO();
			minDate.text="";
			maxDate.text="";
			trace(this + " Init clearFilter");
		}
	}
}
