package forms {
	import dtos.UserDTO;
	import events.InvoicingNavigationMessage;
	import helpers.Constants;
	import mx.containers.Panel;
	import mx.controls.Alert;
	import mx.controls.Label;
	import mx.controls.TextInput;
	import mx.events.CloseEvent;
	import mx.messaging.ChannelSet;
	import mx.messaging.channels.AMFChannel;
	import mx.messaging.messages.ErrorMessage;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.RemoteObject;
	import mx.validators.StringValidator;
	import mx.validators.Validator;
	import screens.HomeScreenCodeBehind;

	/**
	 *
	 * @author Jose
	 */
	public class AuthentificationFormCodeBehind extends Panel {
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var userDTO:UserDTO;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var userNameTextInput:TextInput;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var passwordTextInput:TextInput;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var result:Label;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var authentification:RemoteObject;
		[MessageDispatcher]
		/**
		 *
		 * @default
		 */
		public var sendMessage:Function;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var userNameTextInputValidator:StringValidator;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var passwordTextInputValidator:StringValidator;
		/**
		 *
		 * @default
		 */
		public var validatorArr=new Array();

		/**
		 *
		 */
		public function AuthentificationFormCodeBehind() {
			super();
		}

		/**
		 *
		 */
		public function clickHandlerButton():void {
			if (validateScreen()) {
				var userDTO:UserDTO=new UserDTO();
				userDTO.name=userNameTextInput.text;
				userDTO.password=passwordTextInput.text;
				var channel=new AMFChannel("my-secure-amf", Constants.URI);
				var channelSet:ChannelSet=new ChannelSet();
				channelSet.addChannel(channel);
				authentification.channelSet=channelSet;
				authentification.authenticate(userDTO);
			}
		}

		/**
		 *
		 * @return
		 */
		public function validateScreen():Boolean {
			var arrayResult:Array=Validator.validateAll(validatorArr);
			return (arrayResult.length == 0);
		}

		/**
		 *
		 */
		public function init():void {
			validatorArr.push(userNameTextInputValidator);
			validatorArr.push(passwordTextInputValidator);
		}

		/**
		 *
		 * @param event
		 */
		public function onResult(event:ResultEvent):void {
			userDTO=(event.result as UserDTO);
			if (userDTO != null) {
				Alert.show(resourceManager.getString('invoicingProperties', 'label.userName') + " " + userDTO.name + " " + resourceManager.getString('invoicingProperties', 'label.correctAuthentication'), "Info", 4, this, goToViewStack);
				/*Alert.show(resourceManager.getString('invoicingProperties', 'label.userName') + " " + userDTO.name + " " + resourceManager.getString('invoicingProperties', 'label.correctAuthentication'), "Info");*/
				/*sendMessage(new InvoicingNavigationMessage(InvoicingNavigationMessage.MAINTENANCE, userDTO));*/
			} else {
				Alert.show(resourceManager.getString('invoicingProperties', 'error.authentication'), "Error");
			}
		}

		/**
		 *
		 * @param event
		 */
		public function goToViewStack(event:CloseEvent):void {
			sendMessage(new InvoicingNavigationMessage(InvoicingNavigationMessage.MAINTENANCE, userDTO));
		}

		/**
		 *
		 * @param event
		 */
		public function onFault(event:FaultEvent):void {
			var errorMessage:ErrorMessage=event.message as ErrorMessage;
			trace("message: " + " codeException: " + errorMessage.rootCause.codeException);
			Alert.show(resourceManager.getString('invoicingProperties', 'error.connection'), "Error");
		}
	}
}
