package helpers {
	import mx.formatters.DateFormatter;
	import mx.validators.DateValidator;
	import mx.validators.ValidationResult;

	/**
	 * 
	 * @author Jose
	 */
	public class DateRangeValidator extends DateValidator {
		private var startDate:Date;
		private var endDate:Date;

		/**
		 * 
		 * @param value
		 */
		public function set StartDate(value:Date):void {
			startDate=value;
		}

		/**
		 * 
		 * @param value
		 */
		public function set EndDate(value:Date):void {
			endDate=value;
		}

		/**
		 * 
		 */
		public function DateRangeValidator() {
			super();
		}

		override protected function doValidation(value:Object):Array {
			var validatorResults:Array=new Array();
			validatorResults=super.doValidation(value);
			if (validatorResults.length > 0)
				return validatorResults;
			if (String(value).length == 0)
				return validatorResults;
			var df:DateFormatter=new DateFormatter();
			df.formatString=resourceManager.getString('invoicingProperties', 'DATE_FORMAT');
			var endStringDate:String=df.format(endDate)
			if (Date.parse(value) > Date.parse(endStringDate)) {
				validatorResults.push(new ValidationResult(true, null, resourceManager.getString('invoicingProperties', 'error.invalidDate'), resourceManager.getString('invoicingProperties', 'error.greaterDate')));
				return validatorResults;
			}
			return validatorResults;
		}
	}
}
