package screens {
	import dtos.UserDTO;
	
	import events.ConditionalEvent;
	
	import mx.collections.XMLListCollection;
	import mx.containers.Box;
	import mx.controls.Alert;
	import mx.controls.MenuBar;
	import mx.events.CloseEvent;

	/**
	 *
	 * @author Jose
	 */
	public class HomeScreenCodeBehind extends Box {
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var blockMenuByEdition:Boolean=false;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var isSelectedInvoice:Boolean=false;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var isDoingAction:Boolean=false;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var isMaintenanceState:Boolean=false;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var isSelectedInvoiceAndMaintenance:Boolean=false;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var menuBarCollection:XMLListCollection;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var authentificated:Boolean=false;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var menuBar:MenuBar;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var menubarXML:XMLList;
		[MessageDispatcher]
		/**
		 *
		 * @default
		 */
		public var sendMessage:Function;
		[Bindable]
		/**
		 *
		 * @default
		 */
		public var userDTO:UserDTO;

		/**
		 *
		 */
		public function initCollections():void {
			menuBarCollection=new XMLListCollection(menubarXML);
		}

		/**
		 *
		 * @param command
		 */
		public function executeMenuCommand(command:String):void {
			var conditionalEvent:ConditionalEvent;
			switch (command) {
				case "theProject":  {
					this.currentState="projectState";
					isMaintenanceState=false;
					isSelectedInvoiceAndMaintenance=isMaintenanceState && isSelectedInvoice;
					break;
				}
				case "galery":  {
					this.currentState="galeryState";
					isMaintenanceState=false;
					isSelectedInvoiceAndMaintenance=isMaintenanceState && isSelectedInvoice;
					break;
				}
				case "maintenance":  {
					if (this.currentState != "maintenanceState") {
						this.currentState="maintenanceState";
						isMaintenanceState=true;
						isSelectedInvoiceAndMaintenance=isMaintenanceState && isSelectedInvoice;
					}
					break;
				}
				case "newInvoice":  {
					conditionalEvent=new ConditionalEvent("HomeScreenCodeBehind.newInvoice", true);
					dispatchEvent(conditionalEvent);
					isMaintenanceState=true;
					isSelectedInvoiceAndMaintenance=isMaintenanceState && isSelectedInvoice;
					break;
				}
				case "updateInvoice":  {
					conditionalEvent=new ConditionalEvent("HomeScreenCodeBehind.updateInvoice", true);
					dispatchEvent(conditionalEvent);
					isMaintenanceState=true;
					isSelectedInvoiceAndMaintenance=isMaintenanceState && isSelectedInvoice;
					break;
				}
				case "deleteInvoice":  {
					alertConfirm();
					break;
				}
				default:
					break;
			}
		}

		/**
		 * Metodo que gestiona la habilitación de botones del menú tras la seleccion de un proveedor
		 */
		[MessageHandler(selector="HomeScreenCodeBehind.updateInvoice")]
		[MessageHandler(selector="HomeScreenCodeBehind.newInvoice")]
		[MessageHandler(selector="InvoiceFormCodeBehind.cancelEdition")]
		/**
		 *
		 * @param conditionalEvent
		 */
		public function blockMenuByEd(conditionalEvent:ConditionalEvent):void {
			blockMenuByEdition=conditionalEvent.condition;
		}

		[MessageHandler(selector="InvoicingGrid.isSelectedInoice")]
		/**
		 *
		 * @param conditionalEvent
		 */
		public function searchInvoices(conditionalEvent:ConditionalEvent):void {
			isSelectedInvoice=conditionalEvent.condition;
			isSelectedInvoiceAndMaintenance=isMaintenanceState && isSelectedInvoice;
		}

		private function alertConfirm():void {
			Alert.yesLabel=resourceManager.getString('invoicingProperties', 'label.yes');
			Alert.noLabel=resourceManager.getString('invoicingProperties', 'label.no');
			Alert.show(resourceManager.getString('invoicingProperties', 'question.deleteChangeQuestion')
				, resourceManager.getString('invoicingProperties', 'question.deleteChanges'), 3, this, alertDeleteClickHandler);
		}

		private function alertDeleteClickHandler(event:CloseEvent):void {
			if (event.detail == Alert.YES) {
				var conditionalEvent:ConditionalEvent=new ConditionalEvent("HomeScreenCodeBehind.deleteInvoice", true);
				dispatchEvent(conditionalEvent);
				isMaintenanceState=true;
				isSelectedInvoiceAndMaintenance=false;
			}
		}
	}
}
