package screens {
	import dtos.UserDTO;
	
	import events.InvoicingNavigationMessage;
	
	import flash.net.URLRequest;
	
	import mx.containers.Panel;
	import mx.containers.ViewStack;
	import mx.controls.Button;
	import mx.controls.ComboBox;
	
	import spark.components.NavigatorContent;

	/**
	 * 
	 * @author Jose
	 */
	public class InvoicingScreenCodeBehind extends Panel {
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		public var viewStackScreen:ViewStack;
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		public var maintenanceMainChildScreen:NavigatorContent;
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		public var authenticationChildScreen:NavigatorContent;
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		public var userDTO:UserDTO;
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		public var buttonLogout:Button;
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		public var localeComboBox:ComboBox;
		[Bindable]
		/**
		 * 
		 * @default 
		 */
		protected var locales:Array;

		/**
		 * 
		 */
		public function init():void {
			locales=[{label: resourceManager.getString('invoicingProperties', 'label.spanish'), code: "es_ES"},
				{label: resourceManager.getString('invoicingProperties', 'label.english'), code: "en_US"}];
		}

		/**
		 * 
		 * @param event
		 */
		protected function changeHandler(event:Event):void {
			resourceManager.localeChain=[localeComboBox.selectedItem.code];
		}

		private function logoutFunction():void {
			var ref:URLRequest=new URLRequest("javascript:location.reload(true)");
			flash.net.navigateToURL(ref, "_self");
		}

		[MessageHandler]
		/**
		 * 
		 * @param navigationMessage
		 */
		public function nagivationHandler(navigationMessage:InvoicingNavigationMessage):void {
			userDTO=navigationMessage.userDTO;
			if (authenticationChildScreen != null) {
				switch (navigationMessage.targetNavigatorContent) {
					case InvoicingNavigationMessage.MAINTENANCE:
						if (maintenanceMainChildScreen.deferredContentCreated == false) {
							maintenanceMainChildScreen.createDeferredContent();
						}
						viewStackScreen.selectedChild=maintenanceMainChildScreen;
						buttonLogout.visible=true;
						break;
					default:
						logoutFunction();
						break;
				}
			}
		}
	}
}
