package com.invoicing.dtos;

import java.util.Date;



/**
 * The Class FilterSearchDTO encapsulates the parameters to filter Invoice
 * searches.
 * 
 * @author Jose Carlos
 */
public class FilterSearchDTO {

	/** The user id. */
	private Integer userId;

	/** The max date. */
	private Date maxDate;

	/** The max steps. */
	private String maxSteps;

	/** The max surcharges. */
	private String maxSurcharges;

	/** The max collected. */
	private String maxCollected;

	/** The min date. */
	private Date minDate;

	/** The min steps. */
	private String minSteps;

	/** The min surcharges. */
	private String minSurcharges;

	/** The min collected. */
	private String minCollected;

	/**
	 * Instantiates a new filter search dto.
	 */
	public FilterSearchDTO() {

	}

	/**
	 * Instantiates a new filter search dto.
	 * 
	 * @param userId
	 *            the user id
	 * @param maxDate
	 *            the max date
	 * @param maxSteps
	 *            the max steps
	 * @param maxSurcharges
	 *            the max surcharges
	 * @param maxCollected
	 *            the max collected
	 * @param minDate
	 *            the min date
	 * @param minSteps
	 *            the min steps
	 * @param minSurcharges
	 *            the min surcharges
	 * @param minCollected
	 *            the min collected
	 */
	public FilterSearchDTO(Integer userId, Date maxDate, String maxSteps,
			String maxSurcharges, String maxCollected, Date minDate,
			String minSteps, String minSurcharges, String minCollected) {
		super();
		this.userId = userId;
		this.maxDate = maxDate;
		this.maxSteps = maxSteps;
		this.maxSurcharges = maxSurcharges;
		this.maxCollected = maxCollected;
		this.minDate = minDate;
		this.minSteps = minSteps;
		this.minSurcharges = minSurcharges;
		this.minCollected = minCollected;
	}

	/**
	 * Gets the user id.
	 * 
	 * @return the user id
	 */
	public Integer getUserId() {
		return userId;
	}

	/**
	 * Sets the user id.
	 * 
	 * @param userId
	 *            the new user id
	 */
	public void setUserId(Integer userId) {
		this.userId = userId;
	}

	/**
	 * Gets the max date.
	 * 
	 * @return the max date
	 */
	public Date getMaxDate() {
		return maxDate;
	}

	/**
	 * Sets the max date.
	 * 
	 * @param maxDate
	 *            the new max date
	 */
	public void setMaxDate(Date maxDate) {
		this.maxDate = maxDate;
	}

	/**
	 * Gets the max steps.
	 * 
	 * @return the max steps
	 */
	public String getMaxSteps() {
		return maxSteps;
	}

	/**
	 * Sets the max steps.
	 * 
	 * @param maxSteps
	 *            the new max steps
	 */
	public void setMaxSteps(String maxSteps) {
		this.maxSteps = maxSteps;
	}

	/**
	 * Gets the max surcharges.
	 * 
	 * @return the max surcharges
	 */
	public String getMaxSurcharges() {
		return maxSurcharges;
	}

	/**
	 * Sets the max surcharges.
	 * 
	 * @param maxSurcharges
	 *            the new max surcharges
	 */
	public void setMaxSurcharges(String maxSurcharges) {
		this.maxSurcharges = maxSurcharges;
	}

	/**
	 * Gets the max collected.
	 * 
	 * @return the max collected
	 */
	public String getMaxCollected() {
		return maxCollected;
	}

	/**
	 * Sets the max collected.
	 * 
	 * @param maxCollected
	 *            the new max collected
	 */
	public void setMaxCollected(String maxCollected) {
		this.maxCollected = maxCollected;
	}

	/**
	 * Gets the min date.
	 * 
	 * @return the min date
	 */
	public Date getMinDate() {
		return minDate;
	}

	/**
	 * Sets the min date.
	 * 
	 * @param minDate
	 *            the new min date
	 */
	public void setMinDate(Date minDate) {
		this.minDate = minDate;
	}

	/**
	 * Gets the min steps.
	 * 
	 * @return the min steps
	 */
	public String getMinSteps() {
		return minSteps;
	}

	/**
	 * Sets the min steps.
	 * 
	 * @param minSteps
	 *            the new min steps
	 */
	public void setMinSteps(String minSteps) {
		this.minSteps = minSteps;
	}

	/**
	 * Gets the min surcharges.
	 * 
	 * @return the min surcharges
	 */
	public String getMinSurcharges() {
		return minSurcharges;
	}

	/**
	 * Sets the min surcharges.
	 * 
	 * @param minSurcharges
	 *            the new min surcharges
	 */
	public void setMinSurcharges(String minSurcharges) {
		this.minSurcharges = minSurcharges;
	}

	/**
	 * Gets the min collected.
	 * 
	 * @return the min collected
	 */
	public String getMinCollected() {
		return minCollected;
	}

	/**
	 * Sets the min collected.
	 * 
	 * @param minCollected
	 *            the new min collected
	 */
	public void setMinCollected(String minCollected) {
		this.minCollected = minCollected;
	}
}
