/*
 * 
 */
package com.invoicing.dtos;

import java.util.Date;

/**
 * The Class InvoiceDTO encapsulates business parameters of an invoice
 * 
 * @author Jose Carlos
 */
public class InvoiceDTO {

	/** The id. */
	private Integer id;

	/** The date. */
	private Date date;

	/** The t steps. */
	private Integer tSteps;

	/** The p steps. */
	private Integer pSteps;

	/** The p surcharges. */
	private Integer pSurcharges;

	/** The p collected. */
	private Integer pCollected;

	/** The p time on. */
	private String pTimeOn;

	/** The id user. */
	private int idUser;

	/**
	 * Instantiates a new invoice dto.
	 */
	public InvoiceDTO() {
		super();
	}

	/**
	 * Instantiates a new invoice dto.
	 * 
	 * @param date
	 *            the date
	 * @param tSteps
	 *            the t steps
	 * @param pSteps
	 *            the steps
	 * @param pSurcharges
	 *            the surcharges
	 * @param pCollected
	 *            the collected
	 * @param pTimeOn
	 *            the time on
	 * @param idUser
	 *            the id user
	 */
	public InvoiceDTO(Date date, Integer tSteps, Integer pSteps,
			Integer pSurcharges, Integer pCollected, String pTimeOn, int idUser) {
		super();
		this.date = date;
		this.tSteps = tSteps;
		this.pSteps = pSteps;
		this.pSurcharges = pSurcharges;
		this.pCollected = pCollected;
		this.pTimeOn = pTimeOn;
		this.idUser = idUser;
	}

	/**
	 * Gets the id.
	 * 
	 * @return the id
	 */
	public Integer getId() {
		return id;
	}

	/**
	 * Sets the id.
	 * 
	 * @param id
	 *            the new id
	 */
	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * Gets the date.
	 * 
	 * @return the date
	 */
	public Date getDate() {
		return date;
	}

	/**
	 * Sets the date.
	 * 
	 * @param date
	 *            the new date
	 */
	public void setDate(Date date) {
		this.date = date;
	}

	/**
	 * Gets the t steps.
	 * 
	 * @return the t steps
	 */
	public Integer gettSteps() {
		return tSteps;
	}

	/**
	 * Sets the t steps.
	 * 
	 * @param tSteps
	 *            the new t steps
	 */
	public void settSteps(Integer tSteps) {
		this.tSteps = tSteps;
	}

	/**
	 * Gets the p steps.
	 * 
	 * @return the p steps
	 */
	public Integer getpSteps() {
		return pSteps;
	}

	/**
	 * Sets the p steps.
	 * 
	 * @param pSteps
	 *            the new p steps
	 */
	public void setpSteps(Integer pSteps) {
		this.pSteps = pSteps;
	}

	/**
	 * Gets the p surcharges.
	 * 
	 * @return the p surcharges
	 */
	public Integer getpSurcharges() {
		return pSurcharges;
	}

	/**
	 * Sets the p surcharges.
	 * 
	 * @param pSurcharges
	 *            the new p surcharges
	 */
	public void setpSurcharges(Integer pSurcharges) {
		this.pSurcharges = pSurcharges;
	}

	/**
	 * Gets the p collected.
	 * 
	 * @return the p collected
	 */
	public Integer getpCollected() {
		return pCollected;
	}

	/**
	 * Sets the p collected.
	 * 
	 * @param pCollected
	 *            the new p collected
	 */
	public void setpCollected(Integer pCollected) {
		this.pCollected = pCollected;
	}

	/**
	 * Gets the p time on.
	 * 
	 * @return the p time on
	 */
	public String getpTimeOn() {
		return pTimeOn;
	}

	/**
	 * Sets the p time on.
	 * 
	 * @param pTimeOn
	 *            the new p time on
	 */
	public void setpTimeOn(String pTimeOn) {
		this.pTimeOn = pTimeOn;
	}

	/**
	 * Gets the id user.
	 * 
	 * @return the id user
	 */
	public int getIdUser() {
		return idUser;
	}

	/**
	 * Sets the id user.
	 * 
	 * @param idUser
	 *            the new id user
	 */
	public void setIdUser(int idUser) {
		this.idUser = idUser;
	}
}