package com.invoicing.exceptions;


/**
 * The Class GenericServerException encapsulates parameters of an Exception to send.
 * The view layer will collect this type of exception to treat.
 * 
 * @author Jose Carlos
 */
public class GenericServerException extends Exception {

	/** The Constant serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** The code exception. */
	private String codeException;

	/**
	 * Instantiates a new generic server exception.
	 * 
	 * @param codeException
	 *            the code exception
	 * @param exceptionMessage
	 *            the exception message
	 */
	public GenericServerException(String codeException, String exceptionMessage) {
		super(exceptionMessage);
		this.codeException = codeException;
	}

	/**
	 * Gets the code exception.
	 * 
	 * @return the code exception
	 */
	public String getCodeException() {
		return codeException;
	}

	/**
	 * Sets the code exception.
	 * 
	 * @param codeException
	 *            the new code exception
	 */
	public void setCodeException(String codeException) {
		this.codeException = codeException;
	}
}