package com.invoicing.persistence;

import java.util.List;

import com.invoicing.dtos.FilterSearchDTO;
import com.invoicing.entities.Invoice;

/**
 * The Interface InvoiceDAOI encapsulates the invoice model methods.
 * 
 * @author Jose Carlos
 */
public interface InvoiceDAOI {
	
	/**
	 * Gets the filter invoces list.
	 *
	 * @param filterSearchDTO the filter search dto
	 * @return the filter invoces
	 * @throws Exception the exception
	 */
	public List<Invoice> getFilterInvoces(FilterSearchDTO filterSearchDTO) throws Exception;

	/**
	 * Insert invoice.
	 *
	 * @param invoice the invoice
	 * @return the invoice
	 * @throws Exception the exception
	 */
	public Invoice insertInvoice(Invoice invoice) throws Exception;

	/**
	 * Update invoice.
	 *
	 * @param invoice the invoice
	 * @return the invoice
	 * @throws Exception the exception
	 */
	public Invoice updateInvoice(Invoice invoice) throws Exception;

	/**
	 * Delete invoice.
	 *
	 * @param invoice the invoice
	 * @return the invoice
	 * @throws Exception the exception
	 */
	public Invoice deleteInvoice(Invoice invoice) throws Exception;
}
