package com.invoicing.persistence;

import com.invoicing.entities.User;


/**
 * The Interface UserDAOI encapsulates the user model methods.
 * 
 * @author Jose Carlos
 */
public interface UserDAOI {

	/**
	 * Insert user.
	 * 
	 * @param user
	 *            the user
	 * @throws Exception
	 *             the exception
	 */
	public void insertUser(User user) throws Exception;

	/**
	 * Gets the user.
	 * 
	 * @param userName
	 *            the user name
	 * @param userPassword
	 *            the user password
	 * @return the user
	 * @throws Exception
	 *             the exception
	 */
	public User getUser(String userName, String userPassword) throws Exception;

	/**
	 * Gets the user.
	 * 
	 * @param idUser
	 *            the id user
	 * @return the user
	 * @throws Exception
	 *             the exception
	 */
	User getUser(int idUser) throws Exception;
}