package com.invoicing.persistence;

import java.util.List;

import org.hibernate.Session;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;
import org.springframework.stereotype.Repository;

import com.invoicing.entities.User;


/**
 * The Class UserDAOImpl implements the user model methods.
 * 
 * @author Jose Carlos
 */
@Repository
public class UserDAOImpl extends HibernateDaoSupport implements UserDAOI {

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.invoicing.persistence.UserDAOI#insertUser(com.invoicing.entities.
	 * User)
	 */
	public void insertUser(User user) throws Exception {
		Session session = getSession();
		try {
			session.beginTransaction();
			session.save(user);
			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.invoicing.persistence.UserDAOI#getUser(java.lang.String,
	 * java.lang.String)
	 */
	@SuppressWarnings("unchecked")
	@Override
	public User getUser(String userName, String userPassword) throws Exception {
		Session session = getSession();
		List<User> userList = null;
		try {
			session.beginTransaction();
			userList = session.createQuery(
					"from User as user where user.name = ?").setString(0,
					userName).list();
			session.getTransaction().commit();
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
		return !userList.isEmpty() ? userList.get(0) : null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.invoicing.persistence.UserDAOI#getUser(int)
	 */
	@Override
	public User getUser(int idUser) throws Exception {
		Session session = getSession();
		User user = null;
		try {
			session.beginTransaction();
			user = (User) session.get(User.class, idUser);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			session.close();
		}
		return user;
	}

	/**
	 * Proves.
	 */
	public void proves() {

//		System.out.println("Hibernate one to many (Annotation)");
		Session session = getSession();

		session.beginTransaction();
		// InsertUser
		User user = new User("User1", "Pass1");
		session.save(user);
		// UpdateUser
		// Invoice localInvoice = null;
		// User user = (User) session.get(User.class, new Integer(3));
		// for (Invoice sdr : user.getInvoicingList()) {
		// sdr.setSalto(new Float(533));
		// localInvoice = sdr;
		// }
		// user.getInvoicingList().remove(localInvoice);
		// session.delete(localInvoice);

		// Insert invoices;
		// user = (User) session.get(User.class, new Integer(1));
		// InvoiceDTO invoice1 = new InvoiceDTO();
		// invoice1.setSalto(new Float(111));
		// invoice1.setDate(new Date());
		// invoice1.setUser(user);
		// InvoiceDTO invoice2 = new InvoiceDTO();
		// invoice2.setSalto(new Float(222));
		// Calendar calendar = Calendar.getInstance();
		// calendar.add(Calendar.WEEK_OF_MONTH, 1);
		// Date date = calendar.getTime();
		// invoice2.setDate(date);
		// invoice2.setUser(user);
		// user.getInvoicingList().add(invoice1);
		// user.getInvoicingList().add(invoice2);
		// session.save(invoice1);
		// session.save(invoice2);

		// Stock stock = new Stock();
		// stock.setStockCode("7052");
		// stock.setStockName("PADINI");
		// session.save(stock);

		// StockDailyRecord stockDailyRecords = new StockDailyRecord();
		// stockDailyRecords.setPriceOpen(new Float("1.2"));
		// stockDailyRecords.setPriceClose(new Float("1.1"));
		// stockDailyRecords.setPriceChange(new Float("10.0"));
		// stockDailyRecords.setVolume(3000000L);
		// stockDailyRecords.setDate(new Date());
		// Stock stock = (Stock) session.get(Stock.class, new Integer(1));
		//
		// stockDailyRecords.setStock(stock);
		// stock.getStockDailyRecords().add(stockDailyRecords);
		//
		// session.save(stockDailyRecords);

		// Stock stock = (Stock) session.get(Stock.class, new Integer(1));
		// Query query = null;
		// String HQL = "from StockDailyRecord";
		// query = session.createQuery(HQL);
		// for (StockDailyRecord sdr : stock.getStockDailyRecords()) {
		// session.delete(sdr);
		// }

		// System.out.println(stock.getStockDailyRecords().size());
		session.getTransaction().commit();
//		System.out.println("Done");
		// Query query = null;
		// String HQL = "from User";
		// Session session = getSession();
		// try {
		// query = session.createQuery(HQL);
		// return (List<User>) query.list();
		// } catch (Exception e) {
		// e.printStackTrace();
		// } finally {
		// session.close();
		// }
		// return null;
	}
}
