package com.invoicing.services;

import java.util.List;

import com.invoicing.dtos.FilterSearchDTO;
import com.invoicing.dtos.InvoiceDTO;
import com.invoicing.exceptions.GenericServerException;


/**
 * The Interface InvoiceServiceI encapsulates invoice business methods.
 * 
 * @author Jose Carlos
 */
public interface InvoiceServiceI {

	/**
	 * Filter search.
	 * 
	 * @param filterSearchDTO
	 *            the filter search dto
	 * @return the list
	 * @throws GenericServerException
	 *             the generic server exception
	 */
	public List<InvoiceDTO> filterSearch(FilterSearchDTO filterSearchDTO)
			throws GenericServerException;

	/**
	 * Insert invoice.
	 * 
	 * @param invoiceDTO
	 *            the invoice dto
	 * @return the invoice dto
	 * @throws GenericServerException
	 *             the generic server exception
	 */
	public InvoiceDTO insertInvoice(InvoiceDTO invoiceDTO)
			throws GenericServerException;

	/**
	 * Update invoice.
	 * 
	 * @param invoiceDTO
	 *            the invoice dto
	 * @return the invoice dto
	 * @throws GenericServerException
	 *             the generic server exception
	 */
	public InvoiceDTO updateInvoice(InvoiceDTO invoiceDTO)
			throws GenericServerException;

	/**
	 * Delete invoice.
	 * 
	 * @param invoiceDTO
	 *            the invoice dto
	 * @return the invoice dto
	 * @throws GenericServerException
	 *             the generic server exception
	 */
	public InvoiceDTO deleteInvoice(InvoiceDTO invoiceDTO)
			throws GenericServerException;
}
