package com.invoicing.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.invoicing.dtos.UserDTO;
import com.invoicing.entities.User;
import com.invoicing.exceptions.GenericServerException;
import com.invoicing.persistence.UserDAOI;
import com.invoicing.utilities.Constants;

/**
 * The Interface UserServiceI implements the user business methods.
 * 
 * @author Jose Carlos
 */
@Service
public class UserServiceImpl implements UserServiceI {

	/** The user daoi. */
	@Autowired
	private transient UserDAOI userDAOI;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.invoicing.services.UserServiceI#authenticate(com.invoicing.dtos.UserDTO
	 * )
	 */
	@Override
	public UserDTO authenticate(UserDTO userDTO) throws GenericServerException {

		try {
			User user = userDAOI.getUser(userDTO.getName(), userDTO
					.getPassword());
			if (user != null
					&& user.getPassword().equals(userDTO.getPassword())) {
				userDTO.setPassword(user.getName());
				userDTO.setId(user.getId());
				return userDTO;
			}
		} catch (Exception e) {
			throw new GenericServerException(Constants.USER_EXCEPTION, e
					.getMessage());
		}
		return null;
	}
}