package main.java;

import java.util.List;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import junit.framework.TestCase;

import com.invoicing.dtos.FilterSearchDTO;
import com.invoicing.entities.Invoice;
import com.invoicing.entities.User;
import com.invoicing.persistence.InvoiceDAOI;
import com.invoicing.persistence.UserDAOI;

/**
 * The Class InvoiceTest tests the invoices associated with a user.
 * 
 * @author Jose Carlos
 */
public class InvoiceTest extends TestCase {

	/** The context. */
	private ApplicationContext context;

	/** The user daoi. */
	private UserDAOI userDAOI;

	/** The invoice daoi. */
	private InvoiceDAOI invoiceDAOI;

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() {
		try {
			context = new ClassPathXmlApplicationContext(
					"spring/app-config.xml");
		} catch (Throwable e) {
			// TODO: handle exception
		}
		userDAOI = (UserDAOI) context.getBean("userDAOI");
		invoiceDAOI = (InvoiceDAOI) context.getBean("invoiceDAOI");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() {
		context = null;
		userDAOI = null;
		invoiceDAOI = null;
	}

	/**
	 * Test invoicing.
	 */
	public void testInvoicing() {
		User user = null;
		try {
			user = (User) userDAOI.getUser("Jose Carlos", "123");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		FilterSearchDTO filterSearchDTO = new FilterSearchDTO();
		filterSearchDTO.setUserId(new Integer(1));
		List<Invoice> invoiceList = null;
		try {
			invoiceList = invoiceDAOI.getFilterInvoces(filterSearchDTO);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		for (Invoice invoice : user.getInvoiceList()) {
			boolean trobat = false;
			for (int i = 0; i < invoiceList.size() && !trobat; i++) {
				Invoice invoiceFromInvoiceTable = invoiceList.get(i);
				if ((int) invoice.getId() == (int) invoiceFromInvoiceTable
						.getId()) {
					trobat = true;
				}
			}
			assertTrue("No se ha encontrado una factura en un usuario", trobat);
		}
	}
}
