package main.java;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import junit.framework.TestCase;

import com.invoicing.entities.User;
import com.invoicing.persistence.InvoiceDAOI;
import com.invoicing.persistence.UserDAOI;


/**
 * The Class InvoiceTest tests the  test user there is in the Database
 * 
 * @author Jose Carlos
 */
public class UserTest extends TestCase {

	/** The context. */
	private ApplicationContext context;

	/** The user daoi. */
	private UserDAOI userDAOI;

	/** The invoice daoi. */
	@SuppressWarnings("unused")
	private InvoiceDAOI invoiceDAOI;

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() {

		context = new ClassPathXmlApplicationContext("spring/app-config.xml");
		userDAOI = (UserDAOI) context.getBean("userDAOI");
		invoiceDAOI = (InvoiceDAOI) context.getBean("invoiceDAOI");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() {
		context = null;
		userDAOI = null;
		invoiceDAOI = null;
	}

	/**
	 * Test exist user.
	 */
	public void testExistUser() {
		User user = null;
		try {
			user = (User) userDAOI.getUser("Jose Carlos", "123");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		assertNotNull("No existe el usuario de pruebas", user);
	}
}
